
export function Store(name) {

    let liveTodos;
    const localStorage = window.localStorage;

    function Init() {

    }
    Init();

    /**
     * Read the local ItemList from localStorage.
     *
     * @returns {ItemList} Current array of todos
     */
        function GetLocalStorage() {
        return liveTodos || JSON.parse(localStorage.getItem(name) || '[]');
    };

    /**
     * Write the local ItemList to localStorage.
     *
     * @param {ItemList} todos Array of todos to write
     */
    function SetLocalStorage(todos) {
        localStorage.setItem(name, JSON.stringify(liveTodos = todos));
    };

    async function Insert(item) {
		const todos = GetLocalStorage();
		todos.push(item);
		SetLocalStorage(todos);

    }

    function Find(query) {
		const todos = GetLocalStorage();
        return todos.filter((item) => {
            let include = query(item);
            return include;
        });
    }

    function Update(item) {
		const todos = GetLocalStorage();
        todos.forEach((todo) => {
            if (todo.id == item.id) {
                todo.title = item.title;
                todo.completed = item.completed;
            }
        })
        SetLocalStorage(todos);
    }

    function Delete(item) {
		const todosExisting = GetLocalStorage();
        let todos = [];
        todosExisting.forEach((todo) => {
            if (todo.id != item.id)
                todos.push(todo);
        })
		SetLocalStorage(todos);

    }

    function Count() {
		const todos = GetLocalStorage();
        return todos.length;
    }

    function Completed() {
		const todos = Find((item) => item.completed);
        return todos.length;
    }

    return {
        find: Find,
        insert: Insert,
        update: Update,
        delete: Delete,
        count: Count,
        completed: Completed
    };
}
